<?php
namespace Claromentis\Core\Acl\Simple;

$GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"] = (@$GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"] ?: array()) + array("_938704c4c0169c3804d4bd6aa9941a7" . "6" => base64_decode("Q2FuJ3QgbG9hZCBBQ0w6" . "IG9iamVjdCBjb2RlIG5v" . "dCBzcGVjaWZpZWQ="), "_a7ed4d7408bb99b87a09d89d4212d5" . "de" => base64_decode("c2lt" . "cGxl" . "X2Fj" . "bA=="), "_dbbe14f567" . "693a631f8a4" . "3b65af917ab" => base64_decode("Q2FuJ3QgZGVsZXRlIEFDTCBmc" . "m9tIGRhdGFiYXNlOiBvYmplY3" . "QgY29kZSBub3Qgc3BlY2lmaWV" . "k"), "_84718d82" . "8d2acc3c3" . "66f96b07e" . "841f6a" => base64_decode("YWNsLnNpbXB" . "sZQ=="), "_c95cbc31" . "6178c9769" . "7a403f4d9" . "124106" => base64_decode("U0VMRUNUIHVzZXJfaWQsIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2w" . "gV0hFUkUgb2JqZWN0X2NvZGUgZXE6c3RyOmNvZGU="), "_0877a0b48cf424a0de57a45" . "3ce95e30c" => base64_decode("aW50OnVzZXJfa" . "WQ="), "_3cda3f34ada928e" . "4aa39d4629c5504a" . "a" => base64_decode("aW50OnJ" . "pZ2h0cw" . "=="), "_ef2948c87ef38aab9226e41189b" . "29ca7" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbCBXSEVSRSBvYmplY3RfY29kZSBlcTpzdHI6Y2" . "9kZQ=="), "_a8b22fedb2" . "7a11e07f5bb" . "9a7c73608ea" => base64_decode("c3RyKDEwMCk6b2JqZWN0X2" . "NvZGU="), "_80fc2a45acd0150df87d1" . "fb728940a60" => base64_decode("U0VMRUNUIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2wgV0hF" . "UkUgb2JqZWN0X2NvZGUgZXE6c3RyOmNvZGUgQU5EIHVz" . "ZXJfaWQ9aW50OnVpZA=="), "_b06968b9268deaf3b3" . "80bd0fe922b453" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbCBXSEVSRSBvYmplY3RfY29kZSBlcTpzdHI6Y29kZSBBTkQgdXNlcl9pZD1pbn" . "Q6dWlk"), "_27de5a45db71bf24058769b61b3" . "975a3" => base64_decode("Q2FuJ3Qgc2F2ZSBBQ0w6IG9iamVjdCBjb2RlIG5vdCBzc" . "GVjaWZpZWQ="));
use Claromentis\Core\Acl\Exception\NoObjectException;
use Claromentis\Core\DAL;





class SimpleAclRepository
{
    private $db;
    public function __construct(DAL\Db $db)
    {
        $this->db = $db;
    }
    
    
    
    
    public static function I()
    {
        global $g_application;
        return $g_application[$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53" . "6215"]["_84718d828d2" . "acc3c366f96b" . "07e841f6a"]];
    }
    public function IsGranted(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD) : bool
    {
        if (!$user_id) {
            return false;
        }
        
        
        
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d6" . "653e8a0ab7848e" . "536215"]["_80fc2a45acd0150d" . "f87d1fb728940a60"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
        if (!$_1f24efd4735b7a11b391147435e7d35d->hasData()) {
            return false;
        }
        list($p) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow();
        return ($p & $perms) == $perms;
    }
    public function Grant(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD)
    {
        $this->db->query(new DAL\QueryInsert($GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_a7ed4d7408bb99b87a09d89d" . "4212d5de"], [$GLOBALS["__65da1b1ec2d6653e8a" . "0ab7848e536215"]["_a8b22fedb27a11e07f" . "5bb9a7c73608ea"] => $_65c616d6ef3c21352d2d44595fdf776b, $GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_0877a0b48cf" . "424a0de57a45" . "3ce95e30c"] => $user_id, $GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_3cda3f34ada928e4aa39d4629c" . "5504aa"] => $perms]));
    }
    public function Revoke(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id)
    {
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_b06968b9268deaf3b380bd0f" . "e922b453"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
    }
    
    
    
    
    
    
    
    
    public function Get(string $_65c616d6ef3c21352d2d44595fdf776b) : SimpleAcl
    {
        $acl = new SimpleAcl($_65c616d6ef3c21352d2d44595fdf776b);
        $this->Load($acl);
        return $acl;
    }
    
    
    
    
    
    
    public function Load(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7" . "848e536215"]["_938704c4c" . "0169c3804d" . "4bd6aa9941" . "a76"]);
        }
        $acl->Clear();
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_c95cbc316178c97697a403f4d9124" . "106"], $acl->GetObjectCode());
        while (list($user_id, $perms) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow()) {
            $acl->Set($user_id, $perms);
        }
    }
    
    
    
    
    public function Save(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_27de5a45db71bf24058769b61" . "b3975a3"]);
        }
        $this->Delete($acl);
        $_65c616d6ef3c21352d2d44595fdf776b = $acl->GetObjectCode();
        foreach ($acl->GetRights() as $user_id => $perms) {
            if ($perms) {
                $this->Grant($_65c616d6ef3c21352d2d44595fdf776b, $user_id, $perms);
            }
        }
    }
    
    
    
    
    
    
    public function Delete(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec" . "2d6653e8a0a" . "b7848e53621" . "5"]["_dbbe14f567693a631" . "f8a43b65af917ab"]);
        }
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["_ef2948c87ef" . "38aab9226e41" . "189b29ca7"], $acl->GetObjectCode());
    }
}